/*--------------------------- fftdata1.c ------------------------------ */
/*									*/
/* Author:	Eyal Lebedinsky						*/
/* Date:	Sept 1990						*/
/* Version:	1 Sept 1991						*/
/*									*/
/* Generate sample data to test fft().					*/
/* Use:									*/
/*	fftdata1 >d8f.fft	[or whatever name]			*/
/*									*/
/* This program is released into the public domain.			*/
/*									*/
/*----------------------------------------------------------------------*/

#include <stdio.h>
#include <math.h>

static double	x[256];

main ()
{
	int	i;
	double	twopi, xh;

	printf ("256\n");		/* number of points */

	twopi = 6.2831853071719586;
	xh = 0;
	for (i = 0; i < 256; ++i) {
		x[i] =        sin ( 10 * i * twopi / 256) +
			0.9 * sin ( 20 * i * twopi / 256) +
			0.8 * sin ( 30 * i * twopi / 256) +
			0.7 * sin ( 40 * i * twopi / 256) +
			0.6 * sin ( 50 * i * twopi / 256) +
			0.5 * sin ( 60 * i * twopi / 256) +
			0.4 * sin ( 70 * i * twopi / 256) +
			0.3 * sin ( 80 * i * twopi / 256) +
			0.2 * sin ( 90 * i * twopi / 256) +
			0.1 * sin (100 * i * twopi / 256);
		if (fabs (x[i]) > xh)
			xh = fabs (x[i]);
	}

	for (i = 0; i < 256; ++i)
		printf ("%d\n", (int)(32767 * x[i] / xh));

	exit (0);
}
