/* ------------------------- fftot.c ---------------------------------- */
/*									*/
/* Author:	Eyal Lebedinsky						*/
/* Date:	Jan 1994						*/
/* Version:	22 January 1994						*/
/*									*/
/* called from fftg.c and generates a control table.			*/
/*									*/
/* This program is released into the public domain.			*/
/*									*/
/*----------------------------------------------------------------------*/

#include <stdio.h>
#include <string.h>

void
start_fft (file_name, ep_name)
char	*file_name, *ep_name;
{
	char	fname[256];

	strcpy (fname, file_name);
	strcat (fname, "aa.c");

	freopen (fname, "wt", stdout);
	printf ("static short fft_tab[] = {\n");
}

void
end_fft (file_name, ep_name)
char	*file_name, *ep_name;
{
	printf ("0};\n");
	printf ("#define FFT_NAME %s\n", ep_name);
	printf ("#include \"fftst.c\"\n");
	fclose (stdout);
}

void
fft1 (i1)
int	i1;
{
	printf ("1,%d,\n", 2*i1);
}

void
fft2 (i1, i2)
int	i1, i2;
{
	printf ("2,%d,%d,\n", 2*i1, 2*i2);
}

void
fft3 (i1, i3, i4)
int	i1, i3, i4;
{
	printf ("3,%d,%d,%d,\n", 2*i1, 2*i3, 2*i4);
}

void
fft4 (i1, i2, i3, i4)
int	i1, i2, i3, i4;
{
	printf ("4,%d,%d,%d,%d,\n", 2*i1, 2*i2, 2*i3, 2*i4);
}

void
fft5 (i1, i2, i3, i4, i5, i6, i7, i8, sm1, sp1, cc1, sm3, sp3, cc3, ind)
int	i1, i2, i3, i4, i5, i6, i7, i8, sm1, sp1, cc1, sm3, sp3, cc3, ind;
{
	printf ("5,%d,%d,%d,%d,%d,%d,%d,%d,",
		2*i1, 2*i2, 2*i3, 2*i4, 2*i5, 2*i6, 2*i7, 2*i8);
	printf ("0x%04x,0x%04x,0x%04x,0x%04x,0x%04x,0x%04x,%d,\n",
		(int)(unsigned short)sm1, (int)(unsigned short)sp1,
		(int)(unsigned short)cc1, (int)(unsigned short)sm3,
		(int)(unsigned short)sp3, (int)(unsigned short)cc3, ind);
}

void
fft7 (i1, i2)
int	i1, i2;
{
	printf ("7,%d,%d,\n", 2*i1, 2*i2);
}

void
fft8 (i1, i2, i3)
int	i1, i2, i3;
{
	printf ("8,%d,%d,%d,\n", 2*i1, 2*i2, 2*i3);
}
