/*--------------------------- isqrt.c --------------------------------- */
/*									*/
/* Author:	Eyal Lebedinsky (eyal@ise.canberra.edu.au)		*/
/* Date:	Jan 1994						*/
/* Version:	22 January 1994						*/
/*									*/
/* Used the fft3.c on the power spectrum.				*/
/*									*/
/* This program is released into the public domain.			*/
/*									*/
/*--------------------------------------------------------------------- */

int FAR
isqrt (n)
long	n;
{
	register long	i, j;

	if (n <= 0)
		return (0);

	if (n > 0xffffff)
		i = n >> 16;
	else if (n > 0xffff)
		i = n >> 12;
	else if (n > 0xff)
		i = n >> 8;
	else
		i = n >> 4;
	if (i <= 0)
		i = 1;

	do {
		j = i;
		i = (j + n / j) / 2;
	} while ((i-j) >= 2 || (j-i) >= 2);

	return (i);
}
